; #########################################################################

;     include files
;     ~~~~~~~~~~~~~
      include \MASM32\INCLUDE\windows.inc
      include \MASM32\INCLUDE\masm32.inc
      include \MASM32\INCLUDE\gdi32.inc
      include \MASM32\INCLUDE\user32.inc
      include \MASM32\INCLUDE\kernel32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\ole32.inc

;     libraries
;     ~~~~~~~~~
      includelib \MASM32\LIB\masm32.lib

      includelib \MASM32\LIB\gdi32.lib
      includelib \MASM32\LIB\user32.lib
      includelib \MASM32\LIB\kernel32.lib
      includelib \masm32\lib\oleaut32.lib
      includelib \masm32\lib\ole32.lib

; #########################################################################

        ;=================
        ; Local prototypes
        ;=================
        WinMain      proto :DWORD,:DWORD,:DWORD,:DWORD
        WndProc      proto :DWORD,:DWORD,:DWORD,:DWORD
        LButtonDown  proto hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
        LButtonUp    proto hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
        TopXY        proto :DWORD,:DWORD
        Paint_Proc   proto :DWORD,:DWORD
        StaticImage  proto lpText:DWORD,hParent:DWORD, \
                           a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,ID:DWORD
        DisplayImage  proto lpText:DWORD,hParent:DWORD, \
                           a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,ID:DWORD

        wsprintfA PROTO C :DWORD,:VARARG
        wsprintf equ <wsprintfA>

      ;=============
      ; Local macros
      ;=============

      szText MACRO Name, Text:VARARG
        LOCAL lbl
          jmp lbl
            Name db Text,0
          lbl:
        ENDM

      m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM

      return MACRO arg
        mov eax, arg
        ret
      ENDM

      ;=============================
      ; Window and Bitmap constants
      ;=============================

    BMWIDTH  equ 287                  ; calculator image bitmap width
    BMHEIGHT equ 444                  ; calculator image bitmap height

    ;=============================
    ; Geometry constants
    ;=============================

    WHITE    equ 0
    BLACK    equ 1
    BLUE     equ 2
    TEAL     equ 3
    YELLOW   equ 4

    ;==============================
    ; Calculator keyboard geometry
    ;==============================

geometry MACRO
    XX  "0",    026,400,40,25,WHITE,btn_0
    XX  "1",    026,362,40,25,WHITE,btn_1
    XX  "2",    074,362,40,25,WHITE,btn_2
    XX  "3",    122,362,40,25,WHITE,btn_3
    XX  "4",    026,324,40,25,WHITE,btn_4
    XX  "5",    074,324,40,25,WHITE,btn_5
    XX  "6",    122,324,40,25,WHITE,btn_6
    XX  "7",    026,286,40,25,WHITE,btn_7
    XX  "8",    074,286,40,25,WHITE,btn_8
    XX  "9",    122,286,40,25,WHITE,btn_9
    XX  ".",    074,400,40,25,WHITE,btn_point
    XX  "+/-",  122,400,40,25,WHITE,btn_plusminus
    XX  "+",    170,362,40,25,BLUE ,btn_plus
    XX  "-",    218,362,40,25,BLUE ,btn_minus
    XX  "*",    170,324,40,25,BLUE ,btn_times
    XX  "/",    218,324,40,25,BLUE ,btn_divide
    XX  "EEX",  170,400,40,25,BLUE ,btn_eex
    XX  "ENTER",218,400,40,25,BLUE ,btn_enter
    XX  "DEL",  170,286,40,25,TEAL ,btn_del
    XX  "AC",   218,286,40,25,TEAL ,btn_ac
    XX  "k41",  026,250,32,18,BLACK,btn_k41
    XX  "x><y", 066,250,32,18,BLACK,btn_swapxy
    XX  "x2",   106,250,32,18,BLACK,btn_xsquared
    XX  "sqrt", 146,250,32,18,BLACK,btn_xsqrt
    XX  "log10",186,250,32,18,BLACK,btn_log10
    XX  "logn", 226,250,32,18,BLACK,btn_logn
    XX  "k51",  026,218,32,18,BLACK,btn_k51
    XX  "k52",  066,218,32,18,BLACK,btn_k52
    XX  "hyp",  106,218,32,18,BLACK,btn_hyp
    XX  "sin",  146,218,32,18,BLACK,btn_sin
    XX  "cos",  186,218,32,18,BLACK,btn_cos
    XX  "tan",  226,218,32,18,BLACK,btn_tan
    XX  "shift",026,188,32,18,YELLOW,btn_shift
    XX  "mode", 066,188,32,18,BLACK,btn_mode
    XX  "sto",  106,188,32,18,BLACK,btn_store
    XX  "rcl",  146,188,32,18,BLACK,btn_recall
    XX  "lpu",  186,188,32,18,BLACK,btn_lparenup
    XX  "rpd",  226,188,32,18,BLACK,btn_rparendown
    XX  "k71",  026,157,32,18,BLACK,btn_k71
    XX  "k72",  066,157,32,18,BLACK,btn_k72
    XX  "k73",  106,157,32,18,BLACK,btn_k73
    XX  "k74",  146,157,32,18,BLACK,btn_k74
    XX  "k75",  186,157,32,18,BLACK,btn_k75
    XX  "k76",  226,157,32,18,BLACK,btn_k76
    XX  "k81",  026,126,32,18,TEAL ,btn_k81
    XX  "k82",  066,126,32,18,TEAL ,btn_k82
    XX  "k83",  106,126,32,18,TEAL ,btn_k83
    XX  "k84",  146,126,32,18,TEAL ,btn_k84
    XX  "k85",  186,126,32,18,TEAL ,btn_k85
    XX  "off",  226,126,32,18,TEAL ,btn_off
    XX  "up",   132,097,16,05,TEAL ,btn_scrollup
    XX  "down", 132,104,16,05,TEAL ,bth_scrolldown
    ENDM

; ########################### Inserted modules ############################

;    include ctrls.asm

; #########################################################################

